// Genesaver: copyright 2003 Sam Stafford.

//Enums, constants, and the like.
enum Color { Black, Grey, Green, Red, Blue, Yellow, Cyan, Magenta };

struct Settings
{
	bool save;		//save on exit
	short mutate;	//# mutations per procreation
	char camera;	//camera mode
	int opacity_i;	//animals' opacity in world view
	int digest;		//amount of color an animal can eat per step * 100.
	int radius;		//maximum animal radius
	int vision;		//vision range
	int maxspeed;	//max speed, as percentage
	int fitness;	//steps per fitness check
	int image;		//steps per image rotation
	int diff;		//% diff consumption per image rotation
	int pop;		//population
	char autoscale; //autoscale images if they don't match dimensions
	bool shuffle;	//shuffle images instead of displaying in sequence
	bool alternate;	//use first image on every other rotation
	bool gmo;		//use GMOs for first run instead of random mutants
	char display_buffer; //display buffer, only modified at runtime.
	int smudge; //smudge factor, as a percentage
	int smudgedist; //smudge distance, percentage of velocity

	float opacity_f;
	float digest_f; //amount of color an animal can eat per step.
};

extern Settings settings;

#define A_R settings.radius		// Max animal radius
#define A_S	settings.maxspeed * 0.005	// Max animal speed as a multiple of radius
#define A_D settings.digest_f	// Amount of color an animal can eat per step.
#define A_O settings.opacity_f	// animal opacity
#define A_V settings.vision		// Visual distance in image-pixels.

#define D_M settings.mutate		//Number of times to mutate DNA on a split

#define W_P	settings.pop			//World population (constant)
#define W_F settings.fitness		//Number of steps per fitness check
#define W_I settings.image			//Number of steps per image rotation
#define W_S settings.save			//save genes on exit?
#define W_C settings.diff / 100.0	//percent diff consumption to force an autoswap

#define N_R 0.015				//Neuron radius when rendering brain
#define N_L 0.03				//Neuron label "radius"
#define NULL 0					//null

#include "util.h"

