#ifdef Scenesaver_GLUT

#include <GL/glut.h>
#include <stdio.h>

#include "pixel.h"
#include "world.h"

World* world;

void display()
{
	world->Display();
	glutSwapBuffers();
	glFlush();
}

void keyboard( unsigned char c, int, int )
{
	switch ( c )
	{
	case 'b':
		world->CycleDisplayBuffer();
		break;
	case 'c':
		world->CycleCameraMode();
		break;
	case 's':
		world->Save();
		break;
	}
	display();
}

void resize( int w, int h )
{
	world->Resize( w, h );
	display();
}

void timer( int )
{
	world->Step();
	glutPostRedisplay();
	glutTimerFunc( 1, timer, 0 );
}

int main( int argc, char** argv )
{
	world = new World( argc - 1, argv + 1 );

	glutInit( &argc, argv );
	glutInitDisplayMode( GLUT_DOUBLE | GLUT_ALPHA );
	glutCreateWindow( "Scenesaver" );

	glutDisplayFunc( display );
	glutKeyboardFunc( keyboard );
	glutReshapeFunc( resize );
	glutTimerFunc( 100, timer, 0 );

	glutMainLoop();
	return 0;
}

#endif
